<?php

namespace ClonixDev\AeatSii;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SuministroInformacion' => '\\ClonixDev\\AeatSii\\StructType\\SuministroInformacion',
            'SuministroInformacionBaja' => '\\ClonixDev\\AeatSii\\StructType\\SuministroInformacionBaja',
            'SuministroInformacionCobrosPagos' => '\\ClonixDev\\AeatSii\\StructType\\SuministroInformacionCobrosPagos',
            'SuministroInformacionInmuebles' => '\\ClonixDev\\AeatSii\\StructType\\SuministroInformacionInmuebles',
            'ConsultaInformacion' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaInformacion',
            'ConsultaInformacionCliente' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaInformacionCliente',
            'ConsultaInformacionProveedor' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaInformacionProveedor',
            'CabeceraSii' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraSii',
            'CabeceraSiiBaja' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraSiiBaja',
            'CabeceraSiiCobrosPagos' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraSiiCobrosPagos',
            'DatosPresentacionType' => '\\ClonixDev\\AeatSii\\StructType\\DatosPresentacionType',
            'DatosPresentacion2Type' => '\\ClonixDev\\AeatSii\\StructType\\DatosPresentacion2Type',
            'CabeceraConsultaSii' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraConsultaSii',
            'CabeceraConsultaSiiCliente' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraConsultaSiiCliente',
            'CabeceraConsultaSiiProveedor' => '\\ClonixDev\\AeatSii\\StructType\\CabeceraConsultaSiiProveedor',
            'RegistroSii' => '\\ClonixDev\\AeatSii\\StructType\\RegistroSii',
            'PeriodoLiquidacion' => '\\ClonixDev\\AeatSii\\StructType\\PeriodoLiquidacion',
            'RegistroSiiImputacion' => '\\ClonixDev\\AeatSii\\StructType\\RegistroSiiImputacion',
            'PeriodoImputacion' => '\\ClonixDev\\AeatSii\\StructType\\PeriodoImputacion',
            'OperacionIntracomunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\OperacionIntracomunitariaType',
            'BienDeInversionType' => '\\ClonixDev\\AeatSii\\StructType\\BienDeInversionType',
            'IDFacturaComunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaComunitariaType',
            'IDEmisorFactura' => '\\ClonixDev\\AeatSii\\StructType\\IDEmisorFactura',
            'IDFacturaImputacionType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaImputacionType',
            'ClavePaginacionProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\ClavePaginacionProveedorType',
            'ClavePaginacionClienteType' => '\\ClonixDev\\AeatSii\\StructType\\ClavePaginacionClienteType',
            'ClavePaginacionBienType' => '\\ClonixDev\\AeatSii\\StructType\\ClavePaginacionBienType',
            'IDFacturaConsulta1Type' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaConsulta1Type',
            'IDFacturaExpedidaBCType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaExpedidaBCType',
            'IDFacturaConsulta2Type' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaConsulta2Type',
            'IDFacturaExpedidaType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaExpedidaType',
            'IDFacturaRecibidaType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaRecibidaType',
            'IDFacturaRecibidaNombreType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaRecibidaNombreType',
            'IDFacturaRecibidaNombreBCType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaRecibidaNombreBCType',
            'IDFacturaARType' => '\\ClonixDev\\AeatSii\\StructType\\IDFacturaARType',
            'FacturaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaType',
            'FacturasAgrupadas' => '\\ClonixDev\\AeatSii\\StructType\\FacturasAgrupadas',
            'FacturasRectificadas' => '\\ClonixDev\\AeatSii\\StructType\\FacturasRectificadas',
            'FacturaExpedidaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaExpedidaType',
            'DatosInmueble' => '\\ClonixDev\\AeatSii\\StructType\\DatosInmueble',
            'TipoDesglose' => '\\ClonixDev\\AeatSii\\StructType\\TipoDesglose',
            'DesgloseFacturaRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\DesgloseFacturaRecibidasType',
            'InversionSujetoPasivo' => '\\ClonixDev\\AeatSii\\StructType\\InversionSujetoPasivo',
            'DesgloseIVA' => '\\ClonixDev\\AeatSii\\StructType\\DesgloseIVA',
            'FacturaRecibidaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRecibidaType',
            'CobrosType' => '\\ClonixDev\\AeatSii\\StructType\\CobrosType',
            'PagosType' => '\\ClonixDev\\AeatSii\\StructType\\PagosType',
            'DetalleIVAEmitidaType' => '\\ClonixDev\\AeatSii\\StructType\\DetalleIVAEmitidaType',
            'DetalleExentaType' => '\\ClonixDev\\AeatSii\\StructType\\DetalleExentaType',
            'DetalleIVARecibida2Type' => '\\ClonixDev\\AeatSii\\StructType\\DetalleIVARecibida2Type',
            'DetalleIVAEmitidaPrestacionType' => '\\ClonixDev\\AeatSii\\StructType\\DetalleIVAEmitidaPrestacionType',
            'DetalleIVARecibidaType' => '\\ClonixDev\\AeatSii\\StructType\\DetalleIVARecibidaType',
            'DesgloseRectificacionType' => '\\ClonixDev\\AeatSii\\StructType\\DesgloseRectificacionType',
            'AduanasType' => '\\ClonixDev\\AeatSii\\StructType\\AduanasType',
            'DatosInmuebleType' => '\\ClonixDev\\AeatSii\\StructType\\DatosInmuebleType',
            'DatosPagoCobroType' => '\\ClonixDev\\AeatSii\\StructType\\DatosPagoCobroType',
            'PersonaFisicaJuridicaESType' => '\\ClonixDev\\AeatSii\\StructType\\PersonaFisicaJuridicaESType',
            'PersonaFisicaJuridicaUnicaESType' => '\\ClonixDev\\AeatSii\\StructType\\PersonaFisicaJuridicaUnicaESType',
            'PersonaFisicaJuridicaType' => '\\ClonixDev\\AeatSii\\StructType\\PersonaFisicaJuridicaType',
            'ContraparteConsultaType' => '\\ClonixDev\\AeatSii\\StructType\\ContraparteConsultaType',
            'IDOtroType' => '\\ClonixDev\\AeatSii\\StructType\\IDOtroType',
            'TipoConDesgloseType' => '\\ClonixDev\\AeatSii\\StructType\\TipoConDesgloseType',
            'TipoSinDesgloseType' => '\\ClonixDev\\AeatSii\\StructType\\TipoSinDesgloseType',
            'TipoSinDesglosePrestacionType' => '\\ClonixDev\\AeatSii\\StructType\\TipoSinDesglosePrestacionType',
            'NoSujetaType' => '\\ClonixDev\\AeatSii\\StructType\\NoSujetaType',
            'SujetaType' => '\\ClonixDev\\AeatSii\\StructType\\SujetaType',
            'Exenta' => '\\ClonixDev\\AeatSii\\StructType\\Exenta',
            'NoExenta' => '\\ClonixDev\\AeatSii\\StructType\\NoExenta',
            'SujetaPrestacionType' => '\\ClonixDev\\AeatSii\\StructType\\SujetaPrestacionType',
            'IdRegistroExpInicialType' => '\\ClonixDev\\AeatSii\\StructType\\IdRegistroExpInicialType',
            'DepositoType' => '\\ClonixDev\\AeatSii\\StructType\\DepositoType',
            'VentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\VentaBienesConsignaType',
            'InfoExpedicionRecepcionType' => '\\ClonixDev\\AeatSii\\StructType\\InfoExpedicionRecepcionType',
            'IdRegistroDeclaradoType' => '\\ClonixDev\\AeatSii\\StructType\\IdRegistroDeclaradoType',
            'DestinoFinalExpedRecepType' => '\\ClonixDev\\AeatSii\\StructType\\DestinoFinalExpedRecepType',
            'RangoFechaPresentacionType' => '\\ClonixDev\\AeatSii\\StructType\\RangoFechaPresentacionType',
            'RangoFechaType' => '\\ClonixDev\\AeatSii\\StructType\\RangoFechaType',
            'RegistroDuplicadoType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroDuplicadoType',
            'SuministroLRFacturasEmitidas' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRFacturasEmitidas',
            'LRfacturasEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRfacturasEmitidasType',
            'BajaLRFacturasEmitidas' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRFacturasEmitidas',
            'LRBajaExpedidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaExpedidasType',
            'SuministroLRFacturasRecibidas' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRFacturasRecibidas',
            'LRFacturasRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRFacturasRecibidasType',
            'BajaLRFacturasRecibidas' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRFacturasRecibidas',
            'LRBajaRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaRecibidasType',
            'SuministroLRBienesInversion' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRBienesInversion',
            'LRBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\LRBienesInversionType',
            'BajaLRBienesInversion' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRBienesInversion',
            'LRBajaBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaBienesInversionType',
            'SuministroLRAgenciasViajes' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRAgenciasViajes',
            'LRAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\LRAgenciasViajesType',
            'BajaLRAgenciasViajes' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRAgenciasViajes',
            'LRBajaAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaAgenciasViajesType',
            'SuministroLRCobrosMetalico' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRCobrosMetalico',
            'LRCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\LRCobrosMetalicoType',
            'BajaLRCobrosMetalico' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRCobrosMetalico',
            'LRBajaCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaCobrosMetalicoType',
            'SuministroLROperacionesSeguros' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLROperacionesSeguros',
            'LROperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\LROperacionesSegurosType',
            'BajaLROperacionesSeguros' => '\\ClonixDev\\AeatSii\\StructType\\BajaLROperacionesSeguros',
            'LRBajaRegistroLROperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaRegistroLROperacionesSegurosType',
            'SuministroLRDetOperacionIntracomunitaria' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRDetOperacionIntracomunitaria',
            'LROperacionIntracomunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\LROperacionIntracomunitariaType',
            'BajaLRDetOperacionIntracomunitaria' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRDetOperacionIntracomunitaria',
            'LRBajaOperacionIntracomunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaOperacionIntracomunitariaType',
            'SuministroLRCobrosEmitidas' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRCobrosEmitidas',
            'SuministroLRInmueblesAdicionales' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRInmueblesAdicionales',
            'LRCobrosEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRCobrosEmitidasType',
            'LRInmueblesType' => '\\ClonixDev\\AeatSii\\StructType\\LRInmueblesType',
            'InmueblesAdicionalType' => '\\ClonixDev\\AeatSii\\StructType\\InmueblesAdicionalType',
            'SuministroLRPagosRecibidas' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRPagosRecibidas',
            'LRPagosEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRPagosEmitidasType',
            'SuministroLRVentaBienesConsigna' => '\\ClonixDev\\AeatSii\\StructType\\SuministroLRVentaBienesConsigna',
            'LRVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\LRVentaBienesConsignaType',
            'BajaLRVentaBienesConsigna' => '\\ClonixDev\\AeatSii\\StructType\\BajaLRVentaBienesConsigna',
            'LRBajaVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\LRBajaVentaBienesConsignaType',
            'LRFiltroEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroEmitidasType',
            'LRFiltroFactInformadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroFactInformadasClienteType',
            'LRFiltroFactInformadasAgrupadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroFactInformadasAgrupadasClienteType',
            'LRFiltroFactInformadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroFactInformadasProveedorType',
            'LRFiltroFactInformadasAgrupadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroFactInformadasAgrupadasProveedorType',
            'LRFiltroRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroRecibidasType',
            'LRFiltroBienInversionType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroBienInversionType',
            'LRFiltroDetOperIntracomunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroDetOperIntracomunitariasType',
            'LRFiltroOperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroOperacionesSegurosType',
            'ClavePaginacion' => '\\ClonixDev\\AeatSii\\StructType\\ClavePaginacion',
            'LRFiltroCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroCobrosMetalicoType',
            'LRFiltroAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroAgenciasViajesType',
            'LRFiltroCobrosType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroCobrosType',
            'LRFiltroInmueblesAdicionalesType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroInmueblesAdicionalesType',
            'LRFiltroPagosType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroPagosType',
            'LRFiltroVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\LRFiltroVentaBienesConsignaType',
            'LRConsultaRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaRecibidasType',
            'LRConsultaEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaEmitidasType',
            'ConsultaLRFactInformadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaLRFactInformadasClienteType',
            'ConsultaLRFactInformadasAgrupadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaLRFactInformadasAgrupadasClienteType',
            'ConsultaLRFactInformadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaLRFactInformadasProveedorType',
            'ConsultaLRFactInformadasAgrupadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaLRFactInformadasAgrupadasProveedorType',
            'LRConsultaBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaBienesInversionType',
            'LRConsultaDetOperIntracomunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaDetOperIntracomunitariasType',
            'LRConsultaCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaCobrosMetalicoType',
            'LRConsultaAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaAgenciasViajesType',
            'LRConsultaLROperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaLROperacionesSegurosType',
            'ConsultaCobrosType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaCobrosType',
            'ConsultaPagosType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaPagosType',
            'ConsultaInmueblesAdicionalesType' => '\\ClonixDev\\AeatSii\\StructType\\ConsultaInmueblesAdicionalesType',
            'LRConsultaVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\LRConsultaVentaBienesConsignaType',
            'RespuestaConsultaLRFacturasEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasEmitidasType',
            'RespuestaConsultaLRFacturasRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasRecibidasType',
            'RespuestaConsultaLRFactInformadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFactInformadasClienteType',
            'RespuestaConsultaLRFactInformadasAgrupadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFactInformadasAgrupadasClienteType',
            'RespuestaConsultaLRFactInformadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFactInformadasProveedorType',
            'RespuestaConsultaLRFactInformadasAgrupadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFactInformadasAgrupadasProveedorType',
            'RespuestaConsultaLRBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRBienesInversionType',
            'RespuestaConsultaLRDetOperIntracomunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRDetOperIntracomunitariasType',
            'RespuestaConsultaLRCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRCobrosMetalicoType',
            'RespuestaConsultaLRAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRAgenciasViajesType',
            'RespuestaConsultaLRVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRVentaBienesConsignaType',
            'RespuestaConsultaLROperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLROperacionesSegurosType',
            'RespuestaConsultaLRFacturasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasClienteType',
            'RespuestaConsultaLRFacturasAgrupadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasAgrupadasClienteType',
            'RespuestaConsultaLRFacturasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasProveedorType',
            'RespuestaConsultaLRFacturasAgrupadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasAgrupadasProveedorType',
            'RespuestaConsultaCobrosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaCobrosType',
            'RespuestaConsultaInmueblesAdicionalesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaInmueblesAdicionalesType',
            'RespuestaConsultaPagosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaPagosType',
            'TitularPeriodoType' => '\\ClonixDev\\AeatSii\\StructType\\TitularPeriodoType',
            'EstadoFacturaType' => '\\ClonixDev\\AeatSii\\StructType\\EstadoFacturaType',
            'EstadoFacturaImputacionType' => '\\ClonixDev\\AeatSii\\StructType\\EstadoFacturaImputacionType',
            'DatosDescuadreContraparteType' => '\\ClonixDev\\AeatSii\\StructType\\DatosDescuadreContraparteType',
            'EstadoFactura2Type' => '\\ClonixDev\\AeatSii\\StructType\\EstadoFactura2Type',
            'RegistroRespuestaConsultaEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaEmitidasType',
            'RegistroRespuestaConsultaRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaRecibidasType',
            'RegistroRespuestaConsultaFactInformadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaFactInformadasClienteType',
            'RegistroRespuestaConsultaFactInformadasAgrupadasClienteType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaFactInformadasAgrupadasClienteType',
            'RegistroRespuestaConsultaVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaVentaBienesConsignaType',
            'RegistroRespuestaConsultaFactInformadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaFactInformadasProveedorType',
            'RegistroRespuestaConsultaFactInformadasAgrupadasProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaFactInformadasAgrupadasProveedorType',
            'RegistroRespuestaConsultaBienesType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaBienesType',
            'RegistroRespuestaConsultaDetOperIntracomunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaDetOperIntracomunitariasType',
            'RegistroRespuestaConsultaCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaCobrosMetalicoType',
            'RegistroRespuestaConsultaAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaAgenciasViajesType',
            'RegistroRespuestaConsultaOperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaOperacionesSegurosType',
            'RegistroRespuestaConsultaCobrosType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaCobrosType',
            'RegistroRespuestaConsultaInmueblesAdicionalesType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaInmueblesAdicionalesType',
            'RegistroRespuestaConsultaPagosType' => '\\ClonixDev\\AeatSii\\StructType\\RegistroRespuestaConsultaPagosType',
            'RespuestaDetOperIntracomunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaDetOperIntracomunitariaType',
            'RespuestaCobrosMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaCobrosMetalicoType',
            'RespuestaOperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaOperacionesSegurosType',
            'RespuestaVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaVentaBienesConsignaType',
            'RespuestaConsultaLRFacturasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRFacturasType',
            'RespuestaConsultaLRVentaBVType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaLRVentaBVType',
            'RespuestaConsultaFacturaCobrosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaFacturaCobrosType',
            'RespuestaConsultaInmueblesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaInmueblesType',
            'RespuestaConsultaFacturaPagosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaConsultaFacturaPagosType',
            'FacturaRespuestaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRespuestaType',
            'FacturaRespuestaExpedidaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRespuestaExpedidaType',
            'FacturaRespuestaRecibidaType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRespuestaRecibidaType',
            'FacturaRespuestaInformadaClienteType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRespuestaInformadaClienteType',
            'FacturaRespuestaInformadaProveedorType' => '\\ClonixDev\\AeatSii\\StructType\\FacturaRespuestaInformadaProveedorType',
            'RespuestaComunAltaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaComunAltaType',
            'RespuestaLRFEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRFEmitidasType',
            'RespuestaLRFRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRFRecibidasType',
            'RespuestaLRBajaFRecibidasPagosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaFRecibidasPagosType',
            'RespuestaLRBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBienesInversionType',
            'RespuestaLROComunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLROComunitariasType',
            'RespuestaLRIMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRIMetalicoType',
            'RespuestaLRAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRAgenciasViajesType',
            'RespuestaLROperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLROperacionesSegurosType',
            'RespuestaLRVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRVentaBienesConsignaType',
            'RespuestaComunBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaComunBajaType',
            'RespuestaCobrosPagosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaCobrosPagosType',
            'RespuestaInmueblesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaInmueblesType',
            'RespuestaLRBajaFEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaFEmitidasType',
            'RespuestaLRBajaFRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaFRecibidasType',
            'RespuestaLRBajaBienesInversionType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaBienesInversionType',
            'RespuestaLRBajaOComunitariasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaOComunitariasType',
            'RespuestaLRBajaVentaBienesConsignaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaVentaBienesConsignaType',
            'RespuestaLRBajaIMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaIMetalicoType',
            'RespuestaLRBajaAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaAgenciasViajesType',
            'RespuestaLRBajaOperacionesSegurosType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRBajaOperacionesSegurosType',
            'RespuestaLRCobrosEmitidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRCobrosEmitidasType',
            'RespuestaLRInmueblesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRInmueblesType',
            'RespuestaLRPagosRecibidasType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaLRPagosRecibidasType',
            'RespuestaExpedidaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaExpedidaType',
            'RespuestaExpedidaBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaExpedidaBajaType',
            'RespuestaExpedidaCobroType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaExpedidaCobroType',
            'RespuestaExpedidaInmueblesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaExpedidaInmueblesType',
            'RespuestaRecibidaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaRecibidaType',
            'RespuestaRecibidaBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaRecibidaBajaType',
            'RespuestaRecibidaPagoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaRecibidaPagoType',
            'RespuestaBienType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaBienType',
            'RespuestaBienBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaBienBajaType',
            'RespuestaComunitariaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaComunitariaType',
            'RespuestaComunitariaBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaComunitariaBajaType',
            'RespuestaVentaBienesConsignaBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaVentaBienesConsignaBajaType',
            'RespuestaMetalicoType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaMetalicoType',
            'RespuestaAgenciasViajesType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaAgenciasViajesType',
            'RespuestaMetalicoBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaMetalicoBajaType',
            'RespuestaAgenciasViajesBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaAgenciasViajesBajaType',
            'RespuestaOperacionesSegurosBajaType' => '\\ClonixDev\\AeatSii\\StructType\\RespuestaOperacionesSegurosBajaType',
        );
    }
}
